<?php
/**
 * @package     Joomla.Plugin
 * @subpackage  System.Fields
 *
 * @copyright   Copyright (C) 2005 - 2018 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

use Joomla\Registry\Registry;
use Joomla\CMS\Factory;
use Joomla\CMS\Language\Multilanguage;

/**
 * Joomladcookies Pro Plugin
 */
class PlgContentJoomladcookies extends JPlugin
{
	public function onContentPrepare($context, &$row, &$params, $page = 0)
	{
		$view = null;
		$this->modparams = null;
		$active = true;
		$parts = explode(".", $context);
		$component = $parts[0];
		if(count($parts)>1)
		{
			$view = $parts[1];
		}
		$activecomponents = $this->params->get("component");
		$activeview = $this->params->get("view");
		if($activecomponents=="joomla"&&$component!="com_content")
		{
			$active = false;
		}
		if($component=="com_content")
		{
			if($view=="article")
			{
				if($activeview=="category")
				{
					$active = false;
				}
			}
			elseif($view=="category")
			{
				if($activeview=="article")
				{
					$active = false;
				}
			}
			else
			{
				$active = false;
			}
		}
			
		$this->modparams = $this->getmodparams();
		
		if($this->modparams)
		{
			$this->ytframes = ($this->modparams->get('activeYOUTUBE')&&$this->modparams->get('ytmanageiframes'));
			$this->vmframes = ($this->modparams->get('activeVIMEO')&&$this->modparams->get('vmmanageiframes'));
			$this->dmframes = ($this->modparams->get('activeDAILYMOTION')&&$this->modparams->get('dmmanageiframes'));
			if($this->ytframes||$this->vmframes||$this->dmframes)
			{
				$row->text = $this->processIframes($row->text);
			}
			$this->yturls = ($this->modparams->get('activeYOUTUBE')&&$this->modparams->get('ytmanageurls'));
			$this->vmurls = ($this->modparams->get('activeVIMEO')&&$this->modparams->get('vmmanageurls'));
			$this->dmurls = ($this->modparams->get('activeDAILYMOTION')&&$this->modparams->get('dmmanageurls'));
			if($this->yturls||$this->vmurls||$this->dmurls)
			{
				$row->text = $this->processLinks($row->text);
			}
			if($active)
			{
				$buttons = "";
				if($this->modparams->get('activeFACEBOOK')&&$this->modparams->get('useFacebookAction'))
				{				
					$share = 'data-share="false"';	
					if($this->modparams->get('useFacebookShare'))
					{	
						$share = 'data-share="true"';
					}
					$buttons.='<div class="fb-like" data-layout="'.$this->modparams->get('facebooklayout').'" data-action="'.$this->modparams->get('useFacebookAction').'" '.$share.'></div>';
				}
				if($this->modparams->get('activeTWITTER')&&$this->modparams->get('twitterusername')!=""&&($this->modparams->get('useTwitterShare')||$this->modparams->get('useTwitterFollow')))
				{
					$row->text.='<span class="tacTwitter"></span>';
					if($this->modparams->get('twittersize')=="large")
					{
						$twittersize = 'data-size="large"';
					}
					else
					{
						$twittersize = '';
					}
					if($this->modparams->get('useTwitterShare'))
					{
						$buttons .='<a '.$twittersize.' href="https://twitter.com/share" class="twitter-share-button" data-via="'.$this->modparams->get('twitterusername').'" data-count="none" data-show-count="horizontal" data-dnt="true"></a>';
					}
					if($this->modparams->get('useTwitterFollow'))
					{
						$counter = $this->modparams->get('twittercounter');
						if($counter=='0')
						{
							$counter = "false";
						}
						$buttons .='<a '.$twittersize.' href="https://twitter.com/'.$this->modparams->get('twitterusername').'" class="twitter-follow-button" data-show-count="'.$counter.'" data-dnt="true"></a>';
					}
				}
				if($this->modparams->get('activeGPLUS')&&$this->modparams->get('usegplusshare'))
				{	
					$buttons.='<div class="g-plusone" data-annotation="none"></div>';
				}
				if($this->modparams->get('activeLINKEDIN')&&$this->modparams->get('uselinkedinshare'))
				{
					$buttons.='<span class="tacLinkedin"></span><script type="IN/Share"></script>';
				}
				if($this->modparams->get('activePINTEREST')&&$this->modparams->get('usepinterestshare'))
				{
					$buttons.='<span class="tacPinterest"></span><a href="//www.pinterest.com/pin/create/button/" data-pin-do="buttonBookmark" data-pin-color="white"></a>';
				}
				if($buttons!="")
				{
					$row->text.='<div class="joomladcookies_buttons">'.$buttons.'</div>';
				}
			}
		}
	}

	public function getmodparams()
	{
		jimport('joomla.application.module.helper');
        if(JModuleHelper::isEnabled('mod_joomladcookies'))
        {
	        $module = JModuleHelper::getModule('mod_joomladcookies');
	        $modparams = new JRegistry;
	        $modparams->loadString($module->params);		
	        return $modparams;
	    }
	    else
	    {
	    	return false;
	    }
	}

	public function processIframes($text)
	{
		preg_match_all('#(<iframe.*?>)#', $text, $iframes);
		if(count($iframes)&&count($iframes[0]))
		{
			$iframes = $iframes[0];
			for($x=0;$x<count($iframes);$x++)
			{
				preg_match("/\<iframe.+src\=(?:\"|\')(.+?)(?:\"|\')(?:.+?)\>/", $iframes[$x], $matches);
				if(count($matches)>1)
				{
					if($this->ytframes&&count($matches))
					{
						if(strpos($matches[1],'youtube.com/embed'))
						{					
							$src = $matches[1];
							$parts=explode("/", $src);
							$videoid=$parts[count($parts)-1];
							preg_match("/height\=(?:\"|\')(.+?)(?:\"|\')/", $iframes[$x], $h);
							$height=$h[1];
							preg_match("/width\=(?:\"|\')(.+?)(?:\"|\')/", $iframes[$x], $w);
							$width=$w[1];
							if($width&&!strpos($width, "%")&&!strpos($width, "px"))
							{
								$widthcss = $width."px";
							}
							else
							{
								$widthcss = $width;
							}
							if($height&&!strpos($height, "%")&&!strpos($height, "px"))
							{
								$heightcss = $height."px";
							}
							else
							{
								$heightcss = $height;
							}
							$replace = '<div class="youtube_player" videoid="'.$videoid.'" width="'.$width.'" height="'.$height.'" theme="dark" rel="'.$this->modparams->get('ytrel','0').'" controls="'.$this->modparams->get('ytcontrols','1').'" showinfo="'.$this->modparams->get('ytshowinfo','1').'" autoplay="0" style="width: '.$widthcss.'; height: '.$heightcss.';"><iframe type="text/html" width="'.$width.'" height="'.$height.'" src="//www.youtube-nocookie.com/embed/'.$videoid.'?theme=dark&amp;rel='.$this->modparams->get('ytrel','0').'&amp;controls='.$this->modparams->get('ytcontrols','1').'&amp;showinfo='.$this->modparams->get('ytshowinfo','1').'&amp;autoplay=0" frameborder="0"></iframe></div>';
							$text=str_replace($iframes[$x], $replace, $text);
						}
					}
					if($this->vmframes)
					{
						if(strpos($matches[1],'player.vimeo.com/video'))
						{					
							$src = $matches[1];
							$parts=explode("/", $src);
							$videoid=$parts[count($parts)-1];
							preg_match("/height\=(?:\"|\')(.+?)(?:\"|\')/", $iframes[$x], $h);
							$height=$h[1];
							preg_match("/width\=(?:\"|\')(.+?)(?:\"|\')/", $iframes[$x], $w);
							$width=$w[1];
							$replace = '<div class="vimeo_player" videoID="'.$videoid.'" width="'.$width.'" height="'.$height.'"></div>';
							$text=str_replace($iframes[$x], $replace, $text);
						}
					}
					if($this->dmframes)
					{
						if(strpos($matches[1],'dailymotion.com/embed/video'))
						{					
							$src = $matches[1];
							if(strpos($src, "?autoplay=1")>0)
							{
								$autoplay = "1";
								$src = str_replace("?autoplay=1", "", $src);
							}
							else
							{
								$autoplay = "0";
							}
							$parts=explode("/", $src);
							$videoid=$parts[count($parts)-1];
							preg_match("/height\=(?:\"|\')(.+?)(?:\"|\')/", $iframes[$x], $h);
							$height=$h[1];
							preg_match("/width\=(?:\"|\')(.+?)(?:\"|\')/", $iframes[$x], $w);
							$width=$w[1];
							$replace = '<div class="dailymotion_player" videoID="'.$videoid.'" width="'.$width.'" height="'.$height.'" showinfo="1" autoplay="'.$autoplay.'"></div>';
							$text=str_replace($iframes[$x], $replace, $text);
						}
					}
				}
			}
		}
		return $text;
	}

	public function processLinks($text)
	{
		if($this->yturls)
		{
			$pattern = "`<a href=\"https://(?:www\.youtube\.com/(?:watch\?\S*(?<=\?|&)v=|v/)|youtu\.be/)([a-z0-9_~|-]+)\S*`i"; 
			$width = $this->modparams->get('ytwidth','100%');
			$height = $this->modparams->get('ytheight','100%');
			if(!strpos($width, "%")&&!strpos($width, "px"))
			{
				$widthcss = $width."px";
			}
			else
			{
				$widthcss = $width;
			}
			if(!strpos($height, "%")&&!strpos($height, "px"))
			{
				$heightcss = $height."px";
			}
			else
			{
				$heightcss = $height;
			}
			$replace = '<div class="youtube_player" videoid="$1" width="'.$width.'" height="'.$height.'" theme="dark" rel="'.$this->modparams->get('ytrel','0').'" controls="'.$this->modparams->get('ytcontrols','1').'" showinfo="'.$this->modparams->get('ytshowinfo','1').'" autoplay="0" style="width: '.$widthcss.'; height: '.$heightcss.';"><iframe type="text/html" width="'.$width.'" height="'.$height.'" src="//www.youtube-nocookie.com/embed/$1?theme=dark&amp;rel='.$this->modparams->get('ytrel','0').'&amp;controls='.$this->params->get('controls','1').'&amp;showinfo='.$this->modparams->get('ytshowinfo','1').'&amp;autoplay=0" frameborder="0"></iframe></div>';
			$text = preg_replace ($pattern, $replace, $text);
		}
		if($this->vmurls)
		{
			$pattern = "`<a href=\"(http|https)?:\/\/(www\.)?vimeo.com\/(?:channels\/(?:\w+\/)?|groups\/([^\/]*)\/videos\/|)(\d+)(?:|\/\?)\S*`i";
			$width = $this->modparams->get('vmwidth','100%');
			$height = $this->modparams->get('vmheight','100%');
			$replace = '<div class="vimeo_player" videoID="$4" width="'.$width.'" height="'.$height.'"></div>';
			$text = preg_replace ($pattern, $replace, $text);
		}
		if($this->dmurls)
		{
			$pattern = "`<a href=\"(http|https)://(?:www\.dailymotion\.com/video/|dai\.ly/)([a-z0-9_~|-]+)\S*`i"; 
			$width = $this->modparams->get('dmwidth','100%');
			$height = $this->modparams->get('dmheight','100%');
			$showinfo =  $this->modparams->get('dmshowinfo','1');
			$replace = '<div class="dailymotion_player" videoID="$2" width="'.$width.'" height="'.$height.'" showinfo="'.$showinfo.'" autoplay="0"></div>';
			$text = preg_replace ($pattern, $replace, $text);
		}
		return $text;
	}
}